#include <iostream>
#include <vector>
#include <stdexcept>
using namespace std;

vector<int> find_min_max(vector<int> &arr, int left, int right) {
    if (arr.empty()) throw runtime_error("Array cannot be empty.\n");

    if (left == right) {
        vector<int> result(2, arr[left]);
        return result;
    }
    int mid = (left + right) / 2;
    vector<int> left_arr = find_min_max(arr, left, mid);
    vector<int> right_arr = find_min_max(arr, mid + 1, right);
    vector<int> result = {min(left_arr[0], right_arr[0]), max(left_arr[1], right_arr[1])};
    return result;
}

int main() {
    vector<int> arr = {1, 23, 4, 21, 1, 2, 99};
    vector<int> result = find_min_max(arr, 0, arr.size() - 1);
    cout << "min: " << result[0] << " max: " << result[1] << endl;
    return 0;
}

